<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">搜索 </el-button>
            <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column prop="id" label="ID" width="100"> </el-table-column>
            <el-table-column prop="userId" label="用户ID"> </el-table-column>
            <el-table-column prop="bankCard.realName" label="真实姓名"> </el-table-column>
            <el-table-column prop="bankCard.phone" label="电话"> </el-table-column>
            <el-table-column prop="bankCard.bankName" label="银行"> </el-table-column>
            <el-table-column prop="bankCard.cardNo" label="卡号"> </el-table-column>
            <el-table-column prop="amount" label="金额"> </el-table-column>
            <el-table-column prop="withdrawTime" label="提现时间"> </el-table-column>
            <el-table-column prop="status" label="状态" :formatter="statusFormatter"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button
                        v-if="row.status === 'PENDING'"
                        @click="audit(row, true)"
                        type="primary"
                        size="mini"
                        plain
                        >通过</el-button
                    >
                    <el-button
                        v-if="row.status === 'PENDING'"
                        @click="audit(row, false)"
                        type="primary"
                        size="mini"
                        plain
                        >拒绝</el-button
                    >
<!--                    <el-button
                        v-if="row.status === 'WAIT_TRANSFER'"
                        @click="updateStatus(row, 'SUCCESS')"
                        type="primary"
                        size="mini"
                        plain
                        >已打款</el-button
                    >-->
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'WithdrawApplyList',
    mixins: [pageableTable],
    created() {
        this.getData();
    },
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/withdrawApply/all',
            downloading: false,
            statusOptions: [
                { label: '待审核', value: 'PENDING' },
                { label: '完成', value: 'SUCCESS' },
                { label: '拒绝', value: 'FAIL' }
            ]
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            if (this.search) {
                return { search: this.search };
            }
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/withdrawApplyEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/withdrawApplyEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/withdrawApply/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/withdrawApply/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(action => {
                    if (action === 'cancel') {
                        this.$message.info('删除取消');
                    } else {
                        this.$message.error('删除失败');
                    }
                });
        },
        /*updateStatus(row, status) {
            this.$alert('此操作无法恢复，确认继续？', '提示')
                .then(() => {
                    return this.$http.post('/withdrawApply/updateStatus', {
                        withdrawApplyId: row.id,
                        status: status
                    });
                })
                .then(res => {
                    this.$message.success('成功');
                    this.getData();
                })
                .catch(action => {
                    if (action === 'cancel') {
                        return;
                    } else {
                        this.$message.error('失败');
                    }
                });
        }*/
        audit(row, consent) {
            this.$set(row, 'loading', true);
            this.$http
                .get('/withdrawApply/audit', {
                    id: row.id,
                    consent: consent
                })
                .then(res => {
                    this.$set(row, 'loading', false);
                    this.$message.success('OK');
                    this.getData();
                })
                .catch(e => {
                    console.log(e);
                    this.$set(row, 'loading', false);
                    this.$message.error(e.error);
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
